#include "ScreenCaptureWrapper.h"
#include <fstream> 
using namespace std;

#pragma warning(disable:4482)

typedef int (__stdcall *FnStartScreenCaptureW)(const wchar_t* szDefaultSavePath, void* pCallBack, UINT_PTR hWndNotice, UINT_PTR noticeMsg, UINT_PTR hwndHideWhenCapture, int autoCapture, int x, int y, int width, int height);
FnStartScreenCaptureW gl_StartScreenCapture = NULL;
typedef int (__stdcall *FnInitScreenCaptureW)(const wchar_t* szAuth);
FnInitScreenCaptureW gl_InitCapture = NULL;

typedef int (__stdcall *FnInitCaptureParamW)(int flag, UINT_PTR flagvalue);
FnInitCaptureParamW gl_InitCaptureParam = NULL;


HMODULE CScreenCaptureWrapper::m_hModule = NULL;



CHAR * UnicodeToUtf8(const WCHAR * lpszStr)
{
	CHAR * lpUtf8;
	int nLen;

	if (NULL == lpszStr)
		return NULL;

	nLen = ::WideCharToMultiByte(CP_UTF8, 0, lpszStr, -1, NULL, 0, NULL, NULL);
	if (0 == nLen)
		return NULL;

	lpUtf8 = new CHAR[nLen + 1];
	if (NULL == lpUtf8)
		return NULL;

	memset(lpUtf8, 0, nLen + 1);
	nLen = ::WideCharToMultiByte(CP_UTF8, 0, lpszStr, -1, lpUtf8, nLen, NULL, NULL);
	if (0 == nLen)
	{
		delete []lpUtf8;
		return NULL;
	}

	return lpUtf8;
}

WCHAR * AnsiToUnicode(const CHAR * lpszStr)
{
	WCHAR * lpUnicode;
	int nLen;

	if (NULL == lpszStr)
		return NULL;

	nLen = ::MultiByteToWideChar(CP_ACP, 0, lpszStr, -1, NULL, 0);
	if (0 == nLen)
		return NULL;

	lpUnicode = new WCHAR[nLen + 1];
	if (NULL == lpUnicode)
		return NULL;

	memset(lpUnicode, 0, sizeof(WCHAR) * (nLen + 1));
	nLen = ::MultiByteToWideChar(CP_ACP, 0, lpszStr, -1, lpUnicode, nLen);
	if (0 == nLen)
	{
		delete []lpUnicode;
		return NULL;
	}

	return lpUnicode;
}

WCHAR * Utf8ToUnicode(const CHAR * lpszStr)
{
	WCHAR * lpUnicode;
	int nLen;

	if (NULL == lpszStr)
		return NULL;

	nLen = ::MultiByteToWideChar(CP_UTF8, 0, lpszStr, -1, NULL, 0);
	if (0 == nLen)
		return NULL;

	lpUnicode = new WCHAR[nLen + 1];
	if (NULL == lpUnicode)
		return NULL;

	memset(lpUnicode, 0, sizeof(WCHAR) * (nLen + 1));
	nLen = ::MultiByteToWideChar(CP_UTF8, 0, lpszStr, -1, lpUnicode, nLen);
	if (0 == nLen)
	{
		delete []lpUnicode;
		return NULL;
	}

	return lpUnicode;
}

CHAR * UnicodeToAnsi(const WCHAR * lpszStr)
{
	CHAR * lpAnsi;
	int nLen;

	if (NULL == lpszStr)
		return NULL;

	nLen = ::WideCharToMultiByte(CP_ACP, 0, lpszStr, -1, NULL, 0, NULL, NULL);
	if (0 == nLen)
		return NULL;

	lpAnsi = new CHAR[nLen + 1];
	if (NULL == lpAnsi)
		return NULL;

	memset(lpAnsi, 0, nLen + 1);
	nLen = ::WideCharToMultiByte(CP_ACP, 0, lpszStr, -1, lpAnsi, nLen, NULL, NULL);
	if (0 == nLen)
	{
		delete []lpAnsi;
		return NULL;
	}

	return lpAnsi;
}

string GetCurrentPathA()
{
	char szPath[MAX_PATH] = {0};
	GetModuleFileNameA(NULL, szPath, MAX_PATH);
	string strPath = szPath;
	int nPos = strPath.rfind(L'\\');
	strPath = strPath.substr(0, nPos + 1);
	return strPath;
}

CScreenCaptureWrapper::CScreenCaptureWrapper(void)
{
	
}

CScreenCaptureWrapper::~CScreenCaptureWrapper(void)
{
	
}


bool CScreenCaptureWrapper::IsUseful()
{
	return gl_StartScreenCapture!= NULL;
}

void CScreenCaptureWrapper::FreeLib()
{
	if(m_hModule != NULL)
	{
		FreeLibrary(m_hModule);
		m_hModule = NULL;
	}
}

int CScreenCaptureWrapper::Init(wstring captureName)
{
	if(captureName == _T("niuniu"))
	{
		captureName = _T("");
	}
	FreeLib();	

	string strPath = GetCurrentPathA();
	
	string OwnPath = strPath + "\\NiuNiuCapture.dll";
	//strPath += "\\NiuNiuCapture.dll";
	m_hModule = LoadLibraryA(OwnPath.c_str());	//32λʧܣ64λ 
	
	gl_StartScreenCapture = (FnStartScreenCaptureW)GetProcAddress(m_hModule, "StartScreenCaptureW");
	gl_InitCaptureParam = (FnInitCaptureParamW)GetProcAddress(m_hModule, "InitCaptureParamW");
	gl_InitCapture = (FnInitScreenCaptureW)GetProcAddress(m_hModule, "InitScreenCaptureW");

	
	if(gl_InitCaptureParam != NULL)
	{
		gl_InitCaptureParam(ExtendFlagTypeEnum::emPensize, 2);	//߿
		gl_InitCaptureParam(ExtendFlagTypeEnum::emDrawType, 0);	//÷Ŵ󾵷0 Ѷ   1 360 
		gl_InitCaptureParam(ExtendFlagTypeEnum::emTrackColor, RGB(255, 0, 0));	//Զʶı߿ɫ
		gl_InitCaptureParam(ExtendFlagTypeEnum::emEditBorderColor, RGB(0, 174, 255));	//ֱ༭߿ɫ
		gl_InitCaptureParam(ExtendFlagTypeEnum::emTransparent, 240); //ù͸

		const wchar_t* szSavePath = _T("ţţͼ");
		gl_InitCaptureParam(ExtendFlagTypeEnum::emSetSaveName, (UINT_PTR)szSavePath); //ñʱĿʼ
		//gl_InitCaptureParam(ExtendFlagTypeEnum::emSetMagnifierBkColor, RGB(255, 255, 255)); //÷Ŵ󾵵ıɫ͸

		gl_InitCaptureParam(ExtendFlagTypeEnum::emWindowAware, 1); //˺贰ڴǰãͬ´
	}	
	return 0;
}

int CScreenCaptureWrapper::InitCapture(const wchar_t* szAuth, wstring captureName)
{
	int nRet = Init(captureName);
	if(nRet < 0)
	{
		return nRet;
	}
	if(gl_InitCapture)
	{
		nRet = gl_InitCapture(szAuth);
	}
	return nRet;
}

void CScreenCaptureWrapper::InitParam(int flag, UINT_PTR flagvalue)
{
	if(gl_InitCaptureParam != NULL)
	{
		gl_InitCaptureParam(flag, flagvalue);
	}
}

int CScreenCaptureWrapper::DoCapture(const wchar_t* szDefaultSavePath, void* pCallBack, UINT_PTR hWndNotice, UINT_PTR noticeMsg, UINT_PTR hwndHideWhenCapture, int autoCapture, int x, int y, int width, int height)
{
	if(!gl_StartScreenCapture)
		return 0;
	return gl_StartScreenCapture(szDefaultSavePath, pCallBack, hWndNotice, noticeMsg, hwndHideWhenCapture, 
		autoCapture, x, y, width, height);
}

wstring CScreenCaptureWrapper::GetDefaultSavePath()
{
	string strSavePath = getenv("USERPROFILE");		
	wstring wcsSavePath = AnsiToUnicode(strSavePath.c_str());
	return wcsSavePath;
}