using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using NiuniuRichEDIT;
using System.IO;
using System.Runtime.InteropServices;
namespace WindowsApplicationRichEditTest
{



    public partial class Form1 : Form, IEmotionSelected
    {
        Dictionary<int, string> m_dicStringUrl = new Dictionary<int,string>();
        int WM_MY_MSG_SCREENNOTICE = 0x0400 + 111;
        int SW_SHOWMAXIMIZED = 3;
        EmotionDlg m_emotionDlg = new EmotionDlg();
        Point m_lastPos = new Point();
        string m_strDefaultPath = "";

        [DllImport("shell32.dll")]
        static extern IntPtr ShellExecute(
            IntPtr hwnd,
            string lpOperation,
            string lpFile,
            string lpParameters,
            string lpDirectory,
            int nShowCmd);

        public Form1()
        {
            ScreenCaptureWrapper.Init();
            InitializeComponent();
        }

        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WrapperMsg.WM_NOTIFY)// && EN_PASTE == ((NMHDR)(m.LParam)).codecode)
            {
                NMHDR hdr = (NMHDR)m.GetLParam(typeof(NMHDR));
                if (hdr.code == WrapperMsg.EN_PASTE && hdr.hwndFrom == richTextSend.Handle)
                {
                    RichEditWrapper.Niuniu_PasteMsg(richTextSend.Handle, m.LParam);
                }
                else if (WrapperMsg.EN_LINK == hdr.code)
		        {
                    IntPtr hwndRich = hdr.hwndFrom;
			        ENLINK emLink = (ENLINK)m.GetLParam(typeof(ENLINK));
                    if (emLink.msg == WrapperMsg.WM_LBUTTONDOWN)
			        {
                        int min = emLink.chrg.cpMin;
                        string strUrl = "";
                        if (m_dicStringUrl.ContainsKey(min))
                        {
                            //ҳ
                            //˴Ҳʶ˴һ˺ŵƣʾ˺ 
                            strUrl = m_dicStringUrl[min];
                        }
                        else
                        {
                            int max = emLink.chrg.cpMax;
                            strUrl = RichEditWrapper.GetSelContent(hwndRich, min, max);                            
                        }
                       
                        ShellExecute(IntPtr.Zero, "open", "iexplore.exe", strUrl, "", SW_SHOWMAXIMIZED);
			        }
		        }
            }
            if(m.Msg == WM_MY_MSG_SCREENNOTICE)
            {
                RichEditWrapper.Niuniu_InsertImage(richTextSend.Handle, m_strDefaultPath);
            }
            base.WndProc(ref m);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            m_emotionDlg.m_emotion = this;

            int nRet = RichEditWrapper.Niuniu_InitRichEditWnd(this.Handle, richTextRecord.Handle);
            RichEditWrapper.Niuniu_InitRichEditWnd(this.Handle, richTextSend.Handle);
            InitRichTextBoxMenu(richTextSend);
            InitRichTextBoxMenu(richTextRecord);

            richTextRecord.DetectUrls = true;            
            richTextSend.DetectUrls = true;

            RichEditWrapper.Niuniu_SetDefaultFont(richTextRecord.Handle, "΢ź", 12, ToRGB(Color.Black), WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.FALSE);
            RichEditWrapper.Niuniu_SetDefaultFont(richTextSend.Handle, "΢ź", 12, ToRGB(Color.Black), WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.FALSE);

            AddWelcomMsg();            

        }

        private void AddWelcomMsg()
        {
            string strText = "ӭʹNiuniuRichEditؼҳ롰";

            RichEditWrapper.Niuniu_ReplaceSel(richTextRecord.Handle, strText, "΢ź", 12, ToRGB(Color.Red), WrapperMsg.TRUE, WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.FALSE, 0);

            string strContent = RichEditWrapper.GetRichTextContent(richTextRecord.Handle);
            int nStartPos = strContent.Length;
            m_dicStringUrl[nStartPos] = "http://www.ggniu.cn/?from=4";
            strText = "";
            RichEditWrapper.Niuniu_ReplaceSel(richTextRecord.Handle, strText, "΢ź", 12, ToRGB(Color.Red), WrapperMsg.TRUE, WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.TRUE, 0);

            strText = "\n";
            RichEditWrapper.Niuniu_ReplaceSel(richTextRecord.Handle, strText, "΢ź", 12, ToRGB(Color.Red), WrapperMsg.TRUE, WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.FALSE, 0);
        }


        private void buttonGetContent_Click(object sender, EventArgs e)
        {
            string strContent = RichEditWrapper.GetRichTextContent(richTextSend.Handle);
            AddMsgToRecord(strContent);
            richTextSend.Clear();
            richTextSend.Focus();
        }

        private UInt32 ToRGB(Color color)
        {
            int nColor = color.ToArgb();

            int blue = nColor & 255;

            int green = nColor >> 8 & 255;

            int red = nColor >> 16 & 255;

            return ToRGB(red, green, blue);
        }

        private UInt32 ToRGB(int red, int green, int blue)
        {
            return Convert.ToUInt32(blue << 16 | green << 8 | red);
        }
        
        private void AddMsgToRecord(string lpText)
        {
	        if (string.IsNullOrEmpty(lpText))
		        return;

            /*
             m_richRecord.SetSel(-1, -1);

	CString strTitle = _T("");
	strTitle.Format(_T("ţţ %s:\r\n"), CTime::GetCurrentTime().Format(_T("%H:%M:%S")));
	
	CRichEditHelper::m_fnReplaceSel(m_richRecord.m_hWnd, strTitle, _T("΢ź"), 12, RGB(255, 0, 0), TRUE, FALSE, FALSE, FALSE, 0);
	
	CRichEditHelper::m_fnSetStartIndent(m_richRecord.m_hWnd, 350);

	CRichEditHelper::m_fnAppendMsg(m_richRecord.m_hWnd, lpText);
	CRichEditHelper::m_fnAppendMsg(m_richRecord.m_hWnd, _T("\r\n"));
	CRichEditHelper::m_fnSetStartIndent(m_richRecord.m_hWnd, 0);
	m_richRecord.PostMessage(WM_VSCROLL, SB_BOTTOM, 0);
             * 
             */
            
            RichEditWrapper.Niuniu_SetSel(richTextRecord.Handle, -1, -1);

            string strTitle = string.Format("ţţ {0}:\r\n", DateTime.Now.ToString("HH:mm:ss"));


            RichEditWrapper.Niuniu_ReplaceSel(richTextRecord.Handle, strTitle, "΢ź", 12, ToRGB(Color.Red), WrapperMsg.TRUE, WrapperMsg.FALSE, WrapperMsg.FALSE, WrapperMsg.FALSE, 0);
                    	
            RichEditWrapper.Niuniu_SetStartIndent(richTextRecord.Handle, 350);

            RichEditWrapper.Niuniu_AppendMsg(richTextRecord.Handle, lpText);
            RichEditWrapper.Niuniu_AppendMsg(richTextRecord.Handle, "\r\n");
            RichEditWrapper.Niuniu_SetStartIndent(richTextRecord.Handle, 0);
            richTextRecord.ScrollToCaret();
        }

        private void InitRichTextBoxMenu(RichTextBox textBox)
        {
            MenuItem itemCut = new MenuItem("");
            itemCut.Click += new System.EventHandler(this.MenuItemClick);

            MenuItem itemCopy = new MenuItem("");
            itemCopy.Click += new System.EventHandler(this.MenuItemClick);

            MenuItem itemPaste = new MenuItem("ճ");
            itemPaste.Click += new System.EventHandler(this.MenuItemClick);

            MenuItem itemSaveAs = new MenuItem("Ϊ");
            itemSaveAs.Click += new System.EventHandler(this.MenuItemClick);

            MenuItem itemClear = new MenuItem("");
            itemClear.Click += new System.EventHandler(this.MenuItemClick);

            ContextMenu menu = new ContextMenu();
            menu.MenuItems.Add(itemCut);
            menu.MenuItems.Add(itemCopy);
            menu.MenuItems.Add(itemPaste);
            menu.MenuItems.Add(itemSaveAs);
            menu.MenuItems.Add(itemClear);
            menu.Popup += new System.EventHandler(this.MenuPopUp);
            textBox.ContextMenu = menu;

        }

        private void MenuPopUp(object sender, EventArgs e)
        {
            int nnn = 0;
            ContextMenu menu = (ContextMenu)sender;
            RichTextBox textBox = (RichTextBox)menu.SourceControl;
            Point p = System.Windows.Forms.Control.MousePosition;//
            m_lastPos = textBox.PointToClient(p);
            //Ҫȥ  
            int nHave = RichEditWrapper.Niuniu_HasOleObjectFromPoint(textBox.Handle, m_lastPos.X, m_lastPos.Y);
            foreach (MenuItem menuItem in menu.MenuItems)
            {
                switch (menuItem.Text)
                {
                    case "":
                        menuItem.Enabled = !textBox.ReadOnly;
                        break;
                    case "":
                        
                        break;
                    case "ճ":
                        menuItem.Enabled = !textBox.ReadOnly;
                        break;
                    case "":
                       
                        break;
                    case "Ϊ":
                        {
                            menuItem.Enabled = (nHave == 1);
                        }
                        break;
                }
            }
        }

        private void MenuItemClick(object sender, EventArgs e)
        {
            MenuItem item = (MenuItem)sender;
            ContextMenu menu = (ContextMenu)item.Parent;
            RichTextBox textBox = (RichTextBox)menu.SourceControl;
            switch (item.Text)
            {
                case "":
                    textBox.Cut();
                    break;
                case "":
                    textBox.Copy();
                    break;
                case "ճ":
                    textBox.Paste();
                    break;
                case "":
                    textBox.Clear();
                    break;
                case "Ϊ":
                    RichEditWrapper.Niuniu_SaveOleObjectFromPoint(textBox.Handle, m_lastPos.X, m_lastPos.Y);
                    break;
            }
        }

        private void richTextRecord_MouseUp(object sender, MouseEventArgs e)
        {
            
        }

        private void richTextSend_MouseUp(object sender, MouseEventArgs e)
        {
           
        }

        private void richTextRecord_DoubleClick(object sender, EventArgs e)
        {
            OnRicheditDblClick(richTextRecord);
        }

        private void btnEmotion_Click(object sender, EventArgs e)
        {
           // btnEmotion.Location
           // Point pt = new Point(btnEmotion.Left, btnEmotion.Top);
            Point pt = btnEmotion.PointToScreen(this.Location);
            m_emotionDlg.Hide();
            m_emotionDlg.Show();
            m_emotionDlg.Location = new Point(this.Location.X + btnEmotion.Left + 10, this.Location.Y + btnEmotion.Top - 157 + 30);           
        }

        private void btnScreenShot_Click(object sender, EventArgs e)
        {
            string strPath = System.AppDomain.CurrentDomain.BaseDirectory + "TestCapture\\";
            if(!Directory.Exists(strPath))
            {
                Directory.CreateDirectory(strPath);
            }

            m_strDefaultPath = string.Format("{0}{1}.png", strPath, DateTime.Now.ToFileTime());
           
            ScreenCaptureWrapper.StartScreenCaptureW(m_strDefaultPath, IntPtr.Zero, this.Handle, (UIntPtr)WM_MY_MSG_SCREENNOTICE, IntPtr.Zero, 0, 0, 0, 0, 0);

           
        }

        private void buttonInsert_Click(object sender, EventArgs e)
        {            
            string strPath = "";
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = ("PNG (*.png)|*.png|BMP (*.bmp)|*.bmp|JPG (*.jpg;*.jpeg)|*.jpg;*.jpeg|GIF (*.gif)|*.gif||"); //ļ
            fd.ShowReadOnly = true; //趨ļǷֻ
            DialogResult r = fd.ShowDialog();
            if (r != DialogResult.OK)
            {
                return;
            }
            RichEditWrapper.Niuniu_InsertImage(richTextSend.Handle, fd.FileName);
        }

        public void OnEmotionSelected(int nID)
        {
            string strEmotionPath = string.Format("{0}Emotion\\{1}.gif", System.AppDomain.CurrentDomain.BaseDirectory, nID);
            RichEditWrapper.Niuniu_InsertImage(richTextSend.Handle, strEmotionPath);
        }

        private void richTextSend_DoubleClick(object sender, EventArgs e)
        {
            OnRicheditDblClick(richTextSend);
        }

        private void OnRicheditDblClick(RichTextBox richText)
        {
            Point p = richText.PointToClient(System.Windows.Forms.Control.MousePosition);

            string strPath = RichEditWrapper.GetOleObjectPathFromPoint(richText.Handle, p.X, p.Y);
            if (string.IsNullOrEmpty(strPath))
                return;
            string strExePath = System.AppDomain.CurrentDomain.BaseDirectory + "imageviewer.exe";
            ShellExecute(IntPtr.Zero, "open", strExePath, strPath, "", SW_SHOWMAXIMIZED);
        }

        private void richTextSend_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)   //س
            {
                RichTextBox rich = sender as RichTextBox;
                if (rich == richTextSend)
                {
                    buttonGetContent_Click(null, null);
                    e.Handled = true;
                }
            }
        }
    }
}